#include "xparameters.h"
//#include "xgpio.h"
//#include "xgpio_l.h"
#include "xtmrctr_l.h"
//#include "xintc_l.h"
#include "mb_interface.h"
#include "xps_mems_comm.h"

#include "lcd.h"

Xuint32 baseaddr=(Xuint32) XPAR_XPS_MEMS_COMM_0_BASEADDR;

void writeAcc(Xuint32 address, Xuint32 data) {
	//while((XPS_MEMS_COMM_mReadSlaveReg3(baseaddr,0)& 0xF8000000)); //wait for state to be 0

	XPS_MEMS_COMM_mWriteSlaveReg1(baseaddr, 0, address); //set up address
	XPS_MEMS_COMM_mWriteSlaveReg2(baseaddr, 0, data); //set up data	
	XPS_MEMS_COMM_mWriteSlaveReg8(baseaddr, 0, 1); //triggers a write sequence.
	while((XPS_MEMS_COMM_mReadSlaveReg3(baseaddr,0)& 0x8) == 0x8); //wait until the write is completed
}

Xuint32 readAcc(Xuint32 address) {
//	while((XPS_MEMS_COMM_mReadSlaveReg3(baseaddr,0)& 0xF8000000)); //wait for state to be 0
		
	XPS_MEMS_COMM_mWriteSlaveReg1(baseaddr, 0, address); //set up address
	XPS_MEMS_COMM_mWriteSlaveReg8(baseaddr, 0, 0); //trigger read
	//while((XPS_MEMS_COMM_mReadSlaveReg3(baseaddr,0)& 0xF8000000) == 0); //{
	while((XPS_MEMS_COMM_mReadSlaveReg3(baseaddr,0)& 0x4) ); //{

	return XPS_MEMS_COMM_mReadSlaveReg7(baseaddr,0);
}

Xuint32 readAxis(Xuint32 a) {
	Xuint32 r,d,temp;
	if(a == 0x1) r=0x2; //x
	else if(a == 0x2) r=0x4; //y
	else if(a == 0x3) r=0x6; //z
	else return -1;
	
	temp=readAcc(r);
	temp=temp&0xFF;
	temp=temp>>6;//lsb
	temp=temp&0x3;
	
	d=readAcc(r+1);
	d=d<<2;
	d=d+temp;
	d=d&0x3FF;
	int t = d;
	if(t &0x200) t=t|0xFFFFFC00;
//	if( t < 0 ) t = abs(t);
	return (Xuint32)t;
}

void cont_write_check() {
	Xuint8 x = 0;
	Xuint32 d;
	int i;
	while(1) {
	//for(i=0;i<50;i++) {
		DisplayClear();
		//read 0x13
		x++;
		writeAcc(0x13, x);
		
//		for(i=0;i<150;i++)
//			xil_printf(" ");
			
		d=readAcc(0x13);
		d=d&0xFF;
		WriteString(" c:");
		WriteInt(d);
		
		if( x != d ) {
			xil_printf("\n\rError! x=%d, d=%d\n\r", x, d);
		} else {
			xil_printf("\n\rOK: x=%d, d=%d\n\r", x, d);
		}
	}
}

void manual_poll() {
//		manual axis read
	Xuint32 c;
	int i;
	while(1) {
		DisplayClear();
		c=readAxis(1);
		if(c < 0) {
			WriteString("errorx");
			return;
		}
		WriteInt(c);
		xil_printf("x: %d\t",c);
		SetCursor(1,8);
		
		c=readAxis(2);
		if(c < 0) {
			WriteString("errory");
			return;
		}
		WriteInt(c);
		xil_printf("y: %d\t",c);
		SetCursor(2,1);
		
		c=readAxis(3);
		if(c < 0) {
			WriteString("errorz");
			return;
		}
		WriteInt(c);
		xil_printf("z: %d\n\r",c);
		/*
		//temp
		SetCursor(2,6);
		WriteString("t:");
		c=readAcc(0x08);
		WriteInt(c&0xFF);
			
		for(i=0;i<200000;i++);
//			xil_printf("%d",i);
*/
	}
	
}

int main(void) {
	INIT_LCD();
	DisplayClear();

	int i,j; //used for for loops
	
    // Initialise the peripherals
	while(XPS_MEMS_COMM_mReadSlaveReg3(baseaddr,0) == 0);// wait until the accelerometer is ready to begin

	//need to first set up the accelerometer to communicate in 3pin spi
	writeAcc(0x15,0x08);
	
	//choose slow refresh for low bw
	Xuint32 a;
	a=readAcc(0x14);
	xil_printf("0x14= %x\n\r",a&0xFF);
	a=a&0xE0;
	writeAcc(0x14,a);
	

	//set range to 8g
	Xuint32 q;
	q=readAcc(0x14);
	q=q&0xE7; //8g10
	q=q|0x10;
	writeAcc(0x14,q);
	q=readAcc(0x14);
	q=q>>3;
	q=q&0x3;
	

	XPS_MEMS_COMM_mWriteSlaveReg9(baseaddr, 0, 0x0); //fast clk
	
	Xuint32 c,d;
	
		DisplayClear();
		//read 0x12=162
		d=readAcc(0x12);
		d=d&0xFF;
		WriteString("0x12 ");
		WriteInt(d);
		
		SetCursor(2,1);
		//WriteString("t ");
		
		//read 0x13=13
		d=readAcc(0x13);
		d=d&0xFF;
		SetCursor(2,1);
		WriteString(" 0x13 ");
		WriteInt(d);
		
		//write to customer reg
		writeAcc(0x13, 0xE0);
		
		
//	cont_write_check();
	manual_poll();
	
	return 0;
}


//polling display
/*		c=XPS_MEMS_COMM_mReadSlaveReg4(baseaddr, 0) & 0x7FE;
		WriteInt(c);
		SetCursor(1,8);
		c=XPS_MEMS_COMM_mReadSlaveReg5(baseaddr, 0) & 0x7FE;
		WriteInt(c);
		SetCursor(2,1);
		c=XPS_MEMS_COMM_mReadSlaveReg6(baseaddr, 0) & 0x7FE;
		WriteInt(c);
		for(i=0;i<100;i++)
			xil_printf("%d",i);
*/

//read then write customer registers on accelerometer
/*		//read 0x12
		d=readAcc(0x12);
		d=d&0xFF;
		WriteString("0x12 ");
		WriteInt(d);
		
		SetCursor(2,1);
		//WriteString("t ");
		
		//read 0x13
		d=readAcc(0x13);
		d=d&0xFF;
		SetCursor(2,1);
		WriteString(" 0x13 ");
		WriteInt(d);
		
		//write to customer reg
		writeAcc(0x13, 0x80);
		
		for(i=0;i<5;i++)
			xil_printf("%d",i);

		//read 0x13
		d=readAcc(0x13);
		d=d&0xFF;
		WriteString(" c:");
		WriteInt(d);
*/